unit Expdemo;

{$H-}

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, DB, DBTables, ExtCtrls, StdCtrls, Buttons,
  Gauges, Grids, exporter, ComCtrls;

type
  TExportForm = class(TForm)
    Panel1: TPanel;
    ExportTable: TTable;
    ExportQuery: TQuery;
    ds_Export: TDataSource;
    Panel2: TPanel;
    lbl_Output: TLabel;
    Panel4: TPanel;
    Label1: TLabel;
    eb_MaxRecords: TEdit;
    Panel6: TPanel;
    rb_Table: TRadioButton;
    rb_Query: TRadioButton;
    Label2: TLabel;
    lbl_FieldDelim: TLabel;
    lbl_FieldSep: TLabel;
    lbl_DelimStr: TLabel;
    pnl_DelimStr: TPanel;
    rb_DelimitStrYes: TRadioButton;
    rn_DelimitStrNo: TRadioButton;
    Label6: TLabel;
    rb_ExportTypeV: TRadioButton;
    rb_ExportTypeF: TRadioButton;
    pnl_FieldDelim: TPanel;
    rb_FieldDelimDblQuote: TRadioButton;
    rb_FieldDelimSglQuote: TRadioButton;
    pnl_FieldSep: TPanel;
    rb_FieldSepComma: TRadioButton;
    rb_FieldSepBar: TRadioButton;
    rb_FieldDelimNon: TRadioButton;
    rb_FieldSepTilde: TRadioButton;
    Label7: TLabel;
    eb_Filename: TEdit;
    Label8: TLabel;
    btn_StartExport: TBitBtn;
    Panel5: TPanel;
    rb_OverwriteYes: TRadioButton;
    rb_OverwriteNo: TRadioButton;
    btn_View: TBitBtn;
    sg_ViewFIle: TStringGrid;
    BitBtn1: TBitBtn;
    SpeedButton1: TSpeedButton;
    pnl_Ruler: TPanel;
    ExportTableName: TStringField;
    ExportTableBirthdate: TDateField;
    ExportTableAge: TIntegerField;
    ExportTableLikeable: TBooleanField;
    ExportTableAverageScore: TFloatField;
    ExportTableBinari: TBlobField;
    ExportTableBite: TBytesField;
    ExportTableBeeCeeDee: TBCDField;
    ExportTableMemorandum: TMemoField;
    ExportQueryName: TStringField;
    ExportQueryBirthdate: TDateField;
    ExportQueryAge: TIntegerField;
    ExportQueryLikeable: TBooleanField;
    ExportQueryAverageScore: TFloatField;
    ExportQueryBinari: TBlobField;
    ExportQueryBite: TBytesField;
    ExportQueryBeeCeeDee: TBCDField;
    ExportQueryMemorandum: TMemoField;
    pnl_FieldNames: TPanel;
    rb_FieldNamesYes: TRadioButton;
    rb_FieldNamesNo: TRadioButton;
    Label3: TLabel;
    btn_SeeStats: TBitBtn;
    eb_Age: TEdit;
    Label4: TLabel;
    rb_ShortDate: TRadioButton;
    rb_LongDate: TRadioButton;
    Panel7: TPanel;
    rb_MemosYes: TRadioButton;
    rb_MemosNo: TRadioButton;
    pnl_MemoReturns: TPanel;
    rb_MemoReturnsYes: TRadioButton;
    RadioButton2: TRadioButton;
    btn_Version: TButton;
    Label5: TLabel;
    Panel8: TPanel;
    rb_RecSepCR: TRadioButton;
    rb_RecSepFF: TRadioButton;
    Export1: TExport;
    ExportGauge: TProgressBar;
    procedure btn_StartExportClick(Sender: TObject);
    procedure eb_MaxRecordsExit(Sender: TObject);
    procedure eb_AgeExit(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure rb_TableClick(Sender: TObject);
    procedure rb_QueryClick(Sender: TObject);
    procedure rb_ExportTypeVClick(Sender: TObject);
    procedure rb_ExportTypeFClick(Sender: TObject);
    procedure rb_FieldDelimDblQuoteClick(Sender: TObject);
    procedure rb_FieldDelimSglQuoteClick(Sender: TObject);
    procedure rb_FieldDelimNonClick(Sender: TObject);
    procedure rb_DelimitStrYesClick(Sender: TObject);
    procedure rn_DelimitStrNoClick(Sender: TObject);
    procedure rb_FieldSepCommaClick(Sender: TObject);
    procedure rb_FieldSepBarClick(Sender: TObject);
    procedure rb_FieldSepTildeClick(Sender: TObject);
    procedure rb_OverwriteYesClick(Sender: TObject);
    procedure rb_OverwriteNoClick(Sender: TObject);
    procedure eb_FilenameChange(Sender: TObject);
    procedure btn_ViewClick(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure rb_FieldNamesYesClick(Sender: TObject);
    procedure rb_FieldNamesNoClick(Sender: TObject);
    procedure btn_SeeStatsClick(Sender: TObject);
    procedure export1BeforeExport(Sender: TObject; DataSource: TDataSource;
      RecordCount: Longint; var CanExport: Boolean);
    procedure export1AfterExport(Sender: TObject; DataSource: TDataSource;
      RecordCount: Longint);
    procedure rb_ShortDateClick(Sender: TObject);
    procedure rb_LongDateClick(Sender: TObject);
    procedure rb_MemosYesClick(Sender: TObject);
    procedure rb_MemosNoClick(Sender: TObject);
    procedure RadioButton2Click(Sender: TObject);
    procedure rb_MemoReturnsYesClick(Sender: TObject);
    procedure btn_VersionClick(Sender: TObject);
    procedure rb_RecSepCRClick(Sender: TObject);
    procedure rb_RecSepFFClick(Sender: TObject);
  private
    { Private declarations }
  protected
    TotalAge,Filtered,RecCount: longint;
    ErrCode: byte;
    DateStyle: (Short,Long);
  public
    { Public declarations }
  end;

var
  ExportForm: TExportForm;
  SelectedDataset: string ;

implementation

uses Demoinfo, IniFiles;
{$R *.DFM}

var
FieldSep: string ;
FieldDelim: string ;
FldNames: boolean;
DelimStrOnly: boolean;
ExpType: TexportType;
Fname: string;
NumRecs: longint;
i_Age: integer ;
Overwrite: boolean ;
ViewToggle: boolean;
Inifile: Tinifile;

procedure TExportForm.btn_StartExportClick(Sender: TObject);
var
s_temp: string;
begin
lbl_Output.caption := SelectedDataSet + ': selecting data ... please wait';
lbl_Output.refresh;
Screen.cursor := crHourglass;
ExportGauge.position:=0;
ds_Export.Dataset.open;
Screen.cursor := crDefault;
fname := eb_Filename.text;
  if ExtractFilePath(fname)='' then
    Fname := extractfilepath(Application.exename)+Fname;
  if ExpType = etVariable then
    s_temp := 'Variable'
  else
    s_temp := 'Fixed';
  with inifile do
  begin
  WriteString('EXPORT','Filename',Fname);
  WriteString('EXPORT','FieldDelimiter',FieldDelim);
  WriteString('EXPORT','FieldSeparator',FieldSep);
  WriteBool('EXPORT','FieldNames',FldNames);
  WriteBool('EXPORT','DelimStringOnly',DelimStrOnly);
  WriteString('EXPORT','ExportType',s_temp);
  end;

  with Export1 do
  begin
    if DateStyle = Short then
      if Datasource.DataSet is TTable then
        ExportTableBirthDate.DisplayFormat := 'dd/mm/yy'
      else
        ExportQueryBirthDate.DisplayFormat := 'dd/mm/yy'
    else
      if Datasource.DataSet is TTable then
        ExportTableBirthDate.DisplayFormat := 'dd-mmm-yyyy'
      else
        ExportQueryBirthDate.DisplayFormat := 'dd-mmm-yyyy';
  FieldSeparator := FieldSep;
  FieldDelimiter := FieldDelim;
  DelimitStringsOnly := DelimStrOnly;
  FieldNames := FldNames;
  ExportType := ExpType;
  FileName := Fname;
  NumRecords := NumRecs;
  OverwriteFIle := Overwrite;
  TotalAge := 0 ;
  execute(ErrCode,RecCount,Filtered);
  btn_View.Enabled := true;
  end;
end;

procedure TExportForm.eb_MaxRecordsExit(Sender: TObject);
begin
  try
  NumRecs:=StrToInt(eb_MaxRecords.text);
  except
    on EconvertError do
    with eb_MaxRecords do
    begin
    showmessage(text+ ' is not a valid integer value');
    text := '20';
    refresh;
    NumRecs := 20;
    end;
  end;
end;

procedure TExportForm.eb_AgeExit(Sender: TObject);
begin
  try
  i_Age:=StrToInt(eb_Age.text);
  except
    on EconvertError do
    with eb_Age do
    begin
    showmessage(text+ ' is not a valid integer value');
    text := '99';
    refresh;
    i_Age := 99;
    end;
  end;
end;

procedure TExportForm.FormCreate(Sender: TObject);
begin
RecCount := 0 ;
ErrCode := 0 ;
lbl_Output.caption := 'Table selected for export';
ViewToggle:=true;
FieldSep := ',';
FieldDelim :='"';
FldNames := false;
DelimStrOnly := true;
ExpType := etVariable;
Fname := 'TEST.DAT';
NumRecs := 200;
DateStyle := Short;
i_Age := 99 ;
Overwrite :=true;
Inifile := Tinifile.create(extractfilepath(Application.exename)+'lastexp.ini');
end;

procedure TExportForm.rb_TableClick(Sender: TObject);
begin
ds_Export.Dataset := ExportTable;
SelectedDataSet := 'Table';
lbl_Output.caption := 'Table selected for export';
lbl_Output.refresh;
end;

procedure TExportForm.rb_QueryClick(Sender: TObject);
begin
ds_Export.Dataset := ExportQuery;
SelectedDataSet := 'Query';
lbl_Output.caption := 'Query selected for export';
lbl_Output.refresh;

end;

procedure TExportForm.rb_ExportTypeVClick(Sender: TObject);
begin
ExpType := etVariable;
pnl_FieldDelim.enabled:=true;
pnl_FieldSep.enabled:=true;
pnl_DelimStr.enabled:=true;
lbl_FieldDelim.enabled:=true;
lbl_FieldSep.enabled:=true;
lbl_DelimStr.enabled:=true;
end;

procedure TExportForm.rb_ExportTypeFClick(Sender: TObject);
begin
ExpType := etFixed ;
pnl_FieldDelim.enabled:=false;
pnl_FieldSep.enabled:=false;
pnl_DelimStr.enabled:=false;
lbl_FieldDelim.enabled:=false;
lbl_FieldSep.enabled:=false;
lbl_DelimStr.enabled:=false;
end;

procedure TExportForm.rb_FieldDelimDblQuoteClick(Sender: TObject);
begin
FieldDelim := '"';
pnl_DelimStr.enabled := true;
end;

procedure TExportForm.rb_FieldDelimSglQuoteClick(Sender: TObject);
begin
FieldDelim := '''';
pnl_DelimStr.enabled := true;
end;

procedure TExportForm.rb_FieldDelimNonClick(Sender: TObject);
begin
FieldDelim := '';
pnl_DelimStr.enabled := false;
end;

procedure TExportForm.rb_DelimitStrYesClick(Sender: TObject);
begin
DelimStrOnly := true;
end;

procedure TExportForm.rn_DelimitStrNoClick(Sender: TObject);
begin
DelimStrOnly := false;
end;

procedure TExportForm.rb_FieldSepCommaClick(Sender: TObject);
begin
FieldSep := ',';
end;

procedure TExportForm.rb_FieldSepBarClick(Sender: TObject);
begin
FieldSep := '|';
end;

procedure TExportForm.rb_FieldSepTildeClick(Sender: TObject);
begin
FieldSep:='~';
end;

procedure TExportForm.rb_OverwriteYesClick(Sender: TObject);
begin
Overwrite := true;
end;

procedure TExportForm.rb_OverwriteNoClick(Sender: TObject);
begin
Overwrite := false;
end;

procedure TExportForm.eb_FilenameChange(Sender: TObject);
begin
Fname := eb_Filename.text;
end;

procedure TExportForm.btn_ViewClick(Sender: TObject);
var
sl_Temp: TstringList;
begin
ViewToggle := not ViewToggle;
screen.cursor := crHourGlass;
  if ViewToggle = false then
    begin
    sl_Temp := TstringList.create;
      try
      sl_Temp.LoadFromFile(Fname);
      lbl_Output.caption :='Loading file.......';
      lbl_Output.refresh;
        with sg_ViewFile do
        begin
        RowCount := sl_Temp.count;
        cols[0]:=sl_Temp;
        BringToFront;
        visible:=true;
        pnl_Ruler.BringToFront;
        pnl_Ruler.visible:=true;
        end;
      btn_View.caption := 'Close file view';
      finally
      sl_Temp.free;
      Screen.cursor:=crDefault;
      end;
    end
  else
    begin
    screen.cursor := crHourGlass;
    lbl_Output.caption :='Closing file.......';
    lbl_Output.refresh;
    btn_View.caption := 'View export file';
      with sg_ViewFile do
      begin
      cols[0].clear;
      RowCount := 1 ;
      visible := false;
      SendToBack;
      pnl_Ruler.visible:=false;
      pnl_Ruler.SendToBack;
      end;
    end;
screen.cursor := crDefault;
lbl_Output.caption :='';
lbl_Output.refresh;

end;

procedure TExportForm.SpeedButton1Click(Sender: TObject);
begin
InfoForm := TinfoForm.create(self);
  try
  infoform.showmodal;
  finally
  infoform.release;
  end;
end;

procedure TExportForm.FormDestroy(Sender: TObject);
begin
Inifile.free;
end;

procedure TExportForm.rb_FieldNamesYesClick(Sender: TObject);
begin
FldNames:=true;
end;

procedure TExportForm.rb_FieldNamesNoClick(Sender: TObject);
begin
FldNames := false;
end;

procedure TExportForm.btn_SeeStatsClick(Sender: TObject);
var
i: longint ;
begin
  try
  i := TotalAge DIV (RecCount - Filtered);
  except
  i := 0 ;
  end;
showmessage('Statistics for last export   '+#13+#13+
            'Run time error code          '+#9+IntToStr(ErrCode)+#13+
            'Records processed            '+#9+IntToStr(RecCount)+#13+
            'Records filtered             '+#9+IntToStr(Filtered)+#13+
            'Average age of exported recs '+#9+IntToStr(i)+#13+#13+
            '                                                                            ');
end;

procedure TExportForm.export1BeforeExport(Sender: TObject;
  DataSource: TDataSource; RecordCount: Longint; var CanExport: Boolean);
begin
  if DataSource.DataSet.FieldByName('Age').AsInteger > i_Age then
    CanExport := false
  else
    CanExport := true;
end;

procedure TExportForm.export1AfterExport(Sender: TObject;
  DataSource: TDataSource; RecordCount: Longint);
begin
inc(TotalAge,DataSource.DataSet.FieldByName('Age').AsInteger);
end;

procedure TExportForm.rb_ShortDateClick(Sender: TObject);
begin
DateStyle := Short;
end;

procedure TExportForm.rb_LongDateClick(Sender: TObject);
begin
DateStyle := Long ;
end;

procedure TExportForm.rb_MemosYesClick(Sender: TObject);
begin
Export1.ExportMemos:=True;
pnl_MemoReturns.enabled := true;
end;

procedure TExportForm.rb_MemosNoClick(Sender: TObject);
begin
Export1.ExportMemos:=False;
pnl_MemoReturns.enabled := false;
end;

procedure TExportForm.RadioButton2Click(Sender: TObject);
begin
Export1.ReplaceMemoReturns := false;
end;

procedure TExportForm.rb_MemoReturnsYesClick(Sender: TObject);
begin
Export1.ReplaceMemoReturns := true;
end;

procedure TExportForm.btn_VersionClick(Sender: TObject);
begin
ShowMessage(Export1.Version);
end;

procedure TExportForm.rb_RecSepCRClick(Sender: TObject);
begin
Export1.RecordSeparator := '';
end;

procedure TExportForm.rb_RecSepFFClick(Sender: TObject);
begin
Export1.RecordSeparator := #12;
end;

end.
