unit Impdemo;

{$H-}

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, DB, DBTables, Importer, ExtCtrls, StdCtrls, Buttons,
  Gauges, Grids, DBGrids, ComCtrls;

type
  TImportForm = class(TForm)
    Panel1: TPanel;
    ImportTable: TTable;
    Panel2: TPanel;
    lbl_Output: TLabel;
    Panel3: TPanel;
    btn_StartImport: TBitBtn;
    BitBtn1: TBitBtn;
    btn_ViewImport: TBitBtn;
    Panel4: TPanel;
    Label6: TLabel;
    lbl_FieldDelim: TLabel;
    pnl_FieldDelim: TPanel;
    rb_FieldDelimDblQuote: TRadioButton;
    rb_FieldDelimSglQuote: TRadioButton;
    rb_FieldDelimNon: TRadioButton;
    lbl_DelimStr: TLabel;
    pnl_DelimStr: TPanel;
    rb_DelimitStrYes: TRadioButton;
    rb_DelimitStrNo: TRadioButton;
    lbl_FieldSep: TLabel;
    pnl_FieldSep: TPanel;
    rb_FieldSepComma: TRadioButton;
    rb_FieldSepBar: TRadioButton;
    rb_FieldSepTilde: TRadioButton;
    Label7: TLabel;
    eb_Filename: TEdit;
    Label1: TLabel;
    eb_MaxRecords: TEdit;
    Panel5: TPanel;
    rb_ImportTypeV: TRadioButton;
    rb_importTypeF: TRadioButton;
    ds_Import: TDataSource;
    dbg_Import: TDBGrid;
    btn_View: TBitBtn;
    sg_ViewFIle: TStringGrid;
    pnl_Ruler: TPanel;
    ImportTableName: TStringField;
    ImportTableBornOn: TDateField;
    ImportTableAge: TIntegerField;
    ImportTableLikeable: TBooleanField;
    ImportTableScore: TFloatField;
    ImportTableChecksum: TBCDField;
    btn_ViewStats: TBitBtn;
    Label2: TLabel;
    eb_Age: TEdit;
    Panel6: TPanel;
    rb_CreateLogYes: TRadioButton;
    rb_CreateLogNo: TRadioButton;
    Label3: TLabel;
    btn_Version: TButton;
    SpeedButton1: TSpeedButton;
    Import1: TImport;
    ImportGauge: TProgressBar;
    procedure btn_StartImportClick(Sender: TObject);
    procedure rb_ImportTypeVClick(Sender: TObject);
    procedure rb_importTypeFClick(Sender: TObject);
    procedure rb_FieldDelimDblQuoteClick(Sender: TObject);
    procedure rb_FieldDelimSglQuoteClick(Sender: TObject);
    procedure rb_FieldDelimNonClick(Sender: TObject);
    procedure rb_DelimitStrYesClick(Sender: TObject);
    procedure rb_DelimitStrNoClick(Sender: TObject);
    procedure rb_FieldSepCommaClick(Sender: TObject);
    procedure rb_FieldSepBarClick(Sender: TObject);
    procedure rb_FieldSepTildeClick(Sender: TObject);
    procedure eb_FilenameChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure btn_ViewImportClick(Sender: TObject);
    procedure eb_MaxRecordsExit(Sender: TObject);
    procedure btn_ViewClick(Sender: TObject);
    procedure btn_ViewStatsClick(Sender: TObject);
    procedure eb_AgeExit(Sender: TObject);
    procedure import1BeforePost(Sender: TObject; Table: TTable;
      RecordCount: Longint; var CanImport: Boolean);
    procedure rb_CreateLogNoClick(Sender: TObject);
    procedure rb_CreateLogYesClick(Sender: TObject);
    procedure btn_VersionClick(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
  private
    { Private declarations }
  protected
    ErrCode: byte;
    Processed, Rejected, Filtered: longint;
    ErrLog: string ;
  public
    { Public declarations }
  end;

var
  ImportForm: TImportForm;
  SelectedDataset: string ;
  ViewToggle, ViewFileToggle, CreateLog: boolean;

implementation

uses IniFiles, Demoinf2;

var
FieldSep: string ;
FieldDelim: string ;
DelimStrOnly: boolean;
ImpType: TimportType;
s_Temp, Fname: string;
li_Age, NumRecs: longint ;
{$R *.DFM}

procedure TImportForm.btn_StartImportClick(Sender: TObject);
begin
lbl_Output.caption:='Emptying import table......';
lbl_Output.refresh;
ImportGauge.position:=0;
  with ImportTable do
  begin
    try
    screen.cursor:=crHourglass;
    disablecontrols;
      try
        close;
        exclusive := true;
        emptytable;
        exclusive := false;
        open;
      except
        on EDBEngineError do
        begin
        screen.cursor:=crDefault;
        showmessage('Unable to access IMPORT.DB table!');
        exit;
        end;
      end;
    finally
    enablecontrols;
    screen.cursor:=crDefault;
    end;
  end;
lbl_Output.caption:='';
lbl_Output.refresh;
screen.cursor:=crDefault;
  with Import1 do
  begin
  NumRecords := NumRecs;
  FieldDelimiter := FieldDelim;
  FieldSeparator:=FieldSep;
  Filename:=Fname;
  ImportType:=ImpType;
  {ImportOrder := ioByFieldOrder;}
  CreateErrorLog := CreateLog;  
  execute(ErrCode, Processed, Rejected, Filtered, ErrLog);
  end;
end;

procedure TImportForm.rb_ImportTypeVClick(Sender: TObject);
begin
ImpType := itVariable;
end;

procedure TImportForm.rb_importTypeFClick(Sender: TObject);
begin
ImpType := itFixed;
end;

procedure TImportForm.rb_FieldDelimDblQuoteClick(Sender: TObject);
begin
FieldDelim:='"';
end;

procedure TImportForm.rb_FieldDelimSglQuoteClick(Sender: TObject);
begin
FieldDelim := '''';
end;

procedure TImportForm.rb_FieldDelimNonClick(Sender: TObject);
begin
FieldDelim:='none';
end;

procedure TImportForm.rb_DelimitStrYesClick(Sender: TObject);
begin
DelimStrOnly:=true;
end;

procedure TImportForm.rb_DelimitStrNoClick(Sender: TObject);
begin
DelimStrOnly:=false;
end;

procedure TImportForm.rb_FieldSepCommaClick(Sender: TObject);
begin
FieldSep:=',';
end;

procedure TImportForm.rb_FieldSepBarClick(Sender: TObject);
begin
FieldSep:='|';
end;

procedure TImportForm.rb_FieldSepTildeClick(Sender: TObject);
begin
FieldSep:='~';
end;

procedure TImportForm.eb_FilenameChange(Sender: TObject);
begin
fname:=eb_Filename.text;
end;

procedure TImportForm.FormCreate(Sender: TObject);
begin
s_Temp := ExtractFilePath(Application.ExeName);
FName := s_temp+'TEST.DAT';
FieldDelim := '"';
FieldSep := ',';
DelimStrOnly := true;
ImpType := itVariable;
NumRecs:=200;
li_Age := 99 ;
CreateLog := true;
ViewToggle:=true;

  if FileExists(s_Temp +'lastexp.ini') then
  with Tinifile.create(s_Temp+'lastexp.ini') do
  begin
  Fname:= Readstring('EXPORT','Filename',Fname);
  Fielddelim:= Readstring('EXPORT','FieldDelimiter',Fielddelim);
  FieldSep:= Readstring('EXPORT','FieldSeparator',FieldSep);
  DelimStrOnly:= ReadBool('EXPORT','DelimStringOnly',DelimStrOnly);
  s_temp:= Readstring('EXPORT','ExportType','VARIABLE');
  free;
  end;

  if uppercase(s_Temp) = 'VARIABLE' then
    ImpType := itVariable
  else
    ImpType := itFixed;

  case ImpType of
  itVariable: rb_ImportTypeV.checked := true;
  itFixed   : rb_ImportTypeF.checked := true;
  end;

  case FieldDelim[1] of
  '"'  : rb_FieldDelimDblQuote.checked := true;
  '''' : rb_FieldDelimSglQuote.checked := true;
  else   rb_FieldDelimNon.checked := true;
  end;

  case FieldSep[1] of
  ',' : rb_FieldSepComma.checked := true;
  '|' : rb_FieldSepBar.checked := true;
  '~' : rb_FieldSepTilde.checked := true;
  end;

  case DelimStrOnly of
  true : rb_DelimitStrYes.checked := true;
  false: rb_DelimitStrNo.checked := true;
  end;

eb_Filename.text := fname;

end;

procedure TImportForm.btn_ViewImportClick(Sender: TObject);
begin
  with ImportTable do
  try
  disablecontrols;
  active:=true;
  first;
  finally
  enableControls;
  end;

  with dbg_Import do
    if ViewToggle then
      begin
      BringToFront;
      Visible:=true;
      btn_ViewImport.Caption:='&Close Import View';
      end
    else
      begin
      Visible:=false;
      SendToBack;
      btn_ViewImport.Caption:='&View Import Table';
      end;
ViewToggle := not ViewToggle;
end;

procedure TImportForm.eb_MaxRecordsExit(Sender: TObject);
begin
  try
  NumRecs:=StrToInt(eb_MaxRecords.text)
  except
  on EConvertError do
  NumRecs := 20;
  end;
end;

procedure TImportForm.btn_ViewClick(Sender: TObject);
var
sl_Temp: TstringList;
begin
screen.cursor := crHourGlass;
  if ViewFileToggle = false then
    begin
    sl_Temp := TstringList.create;
      try
      sl_Temp.LoadFromFile(Fname);
      lbl_Output.caption :='Loading file.......';
      lbl_Output.refresh;
        with sg_ViewFile do
        begin
        RowCount := sl_Temp.count;
        cols[0]:=sl_Temp;
        BringToFront;
        visible:=true;
        pnl_Ruler.BringToFront;
        pnl_Ruler.Visible:=true;
        end;
      btn_View.caption := 'Close file view';
      finally
      sl_Temp.free;
      end;
    end
  else
    begin
    screen.cursor := crHourGlass;
    lbl_Output.caption :='Closing file.......';
    lbl_Output.refresh;
    btn_View.caption := 'View export file';
      with sg_ViewFile do
      begin
      cols[0].clear;
      RowCount := 1 ;
      visible := false;
      SendToBack;
      pnl_Ruler.Visible:=false;
      pnl_Ruler.SendToBack;
      end;
    end;
ViewFileToggle := not ViewFileToggle;
screen.cursor := crDefault;
lbl_Output.caption :='';
lbl_Output.refresh;

end;

procedure TImportForm.btn_ViewStatsClick(Sender: TObject);
begin
showmessage('Statistics for last import:'+#13+#13+
            'Run time error code        '+#9+IntToStr(ErrCode)+#13+
            'Records processed          '+#9+IntToStr(Processed)+#13+
            'Records rejected           '+#9+IntToStr(Rejected)+#13+
            'Records filtered                  '+#9+IntToStr(Filtered)+#13+
            'Import Error log               '+#9+ErrLog+#13+#13+
            '                                                                            ');
end;

procedure TImportForm.eb_AgeExit(Sender: TObject);
begin
  try
  li_Age:=StrToInt(eb_Age.text)
  except
  on EConvertError do
  li_Age := 99;
  end;

end;

procedure TImportForm.import1BeforePost(Sender: TObject; Table: TTable;
  RecordCount: Longint; var CanImport: Boolean);
begin
  if Table.FieldByName('Age').AsInteger > li_Age then
    CanImport := false
  else
    CanImport := true;
end;

procedure TImportForm.rb_CreateLogNoClick(Sender: TObject);
begin
CreateLog := false;
end;

procedure TImportForm.rb_CreateLogYesClick(Sender: TObject);
begin
CreateLog := True;
end;

procedure TImportForm.btn_VersionClick(Sender: TObject);
begin
ShowMessage(Import1.Version);
end;

procedure TImportForm.SpeedButton1Click(Sender: TObject);
begin
ImpInfoForm := TImpinfoForm.create(self);
  try
  Impinfoform.showmodal;
  finally
  Impinfoform.release;
  end;

end;

end.
